package edu.uci.ics.seal.savasana;

import java.util.Arrays;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import edu.uci.ics.seal.savasana.benchmark.SystemUnderTest;

public class Const {

	public static int SPEED = 1;

	/** Average runtime of transactions */
	public static final long AVERAGE_RUNTIME = 5000 / SPEED;
	/** Wait time before sending runtime signal and monitoring. */
	public static final int WARM_UP_TIME = 2500 / SPEED;
	/** Average inter-arrival request time (lambda value) */
	public static final double LAMBDA = 0.5 * SPEED;
	/** Total number of system execution */
	public static final int TRANSACTION_NUMBERS = 10;

	public static final int REQUEST_DELAY = WARM_UP_TIME * 4;

	public static final String SYS_THREAD_PREFIX = "SUT_";
	public static final ApplicationContext CONTEXT = new ClassPathXmlApplicationContext("SpringBeans.xml");
	public static final SystemUnderTest SUTs[] = new SystemUnderTest[] { /*new Sys1(), new Sys2(), new Sys3(), new Sys4(), new Sys5(),*/ };

	/** Enabling verbose Log */
	public static LogLevel VERBOSE_LEVEL = LogLevel.VERBOSE;
	public static SystemUnderTest SUT = SUTs[0];
	public static AdaptationApproach ADAPTATION_APPROACH = AdaptationApproach.SAVASANA;

	public static String OUTPUT_File = null;
	public static boolean EARLY_SHUTDOWN = false;

	public enum AdaptationApproach {
		SAVASANA('s'), TRANQUILITY('t');

		AdaptationApproach(char val) {
			this.val = val;
		}

		char val;

		public static AdaptationApproach getApproach(char c) {
			return Arrays.asList(AdaptationApproach.values()).stream().filter(a -> a.val == c).findFirst().get();
		}
	}

	public enum LogLevel {
		SILENT(3, 's'), QUIET(2, 'q'), CONCISE(1, 'c'), VERBOSE(0, 'v');

		LogLevel(int val, char c) {
			this.val = val;
			this.shortName = c;
		}

		int val;
		char shortName;

		public static LogLevel getLoglevel(char c) {
			return Arrays.asList(LogLevel.values()).stream().filter(a -> a.shortName == c).findFirst().get();
		}

	}
}
