package edu.uci.ics.seal.savasana.benchmark.testset.eds;

import edu.uci.ics.seal.savasana.benchmark.testset.eds.map.Map;
import edu.uci.ics.seal.savasana.benchmark.testset.eds.repository.Repository;
import edu.uci.ics.seal.savasana.benchmark.testset.eds.serenityExtension.EDSManager;
import edu.uci.ics.seal.savasana.benchmark.testset.eds.weather.Weather;
import edu.uci.ics.seal.savasana.runtime_old.Adaptor;
import edu.uci.ics.seal.savasana.runtime_old.Main_Old;
import edu.uci.ics.seal.savasana.runtime_old.Main_Old.TestScenario;

public class HQUI implements Runnable {

	public static Map map;
	public static Weather weather;
	public static Repository repository;
	SimulationAgent simulationAgent;
	StrategyAnalyzer strategyAnalyzer;
	DeploymentAdvisor deploymentAdvisor;
	ResourceMonitor resourceMonitor;

	public void init() {

	}

	public void doTransaction() {
		if (Main_Old.scenario == TestScenario.ANALYZER)
			strategyAnalysisScenario();
		else if (Main_Old.scenario == TestScenario.SIMULATOR)
			resourceEstimationScenario();
		else if (Main_Old.scenario == TestScenario.ADVISOR)
			deploymentScenario();
	}

	private void resourceEstimationScenario() {
		map = (Map) EDSManager.context.getBean(EDSManager.prop.getProperty("map_id"));
		simulationAgent = (SimulationAgent) EDSManager.context.getBean("simAgent");
		map.foo();
		map.initMap(new double[] { 10.0, 10.0 });
		simulationAgent.doTransaction();
		Double distanceToTarget = map.getTimeToTarget();
		System.out.println("Simulation Result: Distance to the target is " + distanceToTarget);
	}

	private void strategyAnalysisScenario() {
		weather = (Weather) EDSManager.context.getBean(EDSManager.prop.getProperty("weather_id"));
		strategyAnalyzer = (StrategyAnalyzer) EDSManager.context.getBean("strategy_analyzer");
		weather.foo();
		weather.setMeasurementDefaultUnit("c");
		strategyAnalyzer.doTransaction();
		Double temperatureInDefaultUnit = weather.getTemperatureInDefaultUnit();
		System.out.println("Temperatue is " + temperatureInDefaultUnit + " in default system unit");
	}

	private void deploymentScenario() {
		repository = (Repository) EDSManager.context.getBean(EDSManager.prop.getProperty("repository_id"));
		deploymentAdvisor = (DeploymentAdvisor) EDSManager.context.getBean("advisor");
		resourceMonitor = (ResourceMonitor) EDSManager.context.getBean("resource_monitor");
		resourceMonitor.doTransaction();
		deploymentAdvisor.doTransaction();
		int numOfActiveRescuers = repository.getNumOfActiveRescuers();
		System.out.println("Number of Active Rescuers are " + numOfActiveRescuers);
	}

	@Override
	public void run() {
		int threadIndex = Integer.parseInt(Thread.currentThread().getName().split(Adaptor.COMPONENT_THREAD_PREFIX)[1]);
		long waitTime = Main_Old.interArrivalTime[threadIndex];
		long waitedTime = System.currentTimeMillis() - Main_Old.startTime;
		long remainingTime = waitTime - waitedTime;
		if (remainingTime > 0) {
			try {
				Thread.sleep(remainingTime);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		Main_Old.runningThreads.add(Thread.currentThread().getName());
		doTransaction();
	}
}
