package edu.uci.ics.seal.savasana.benchmark.testset.eds.serenityExtension;

import java.io.IOException;
import java.util.Properties;

import org.springframework.context.ApplicationContext;

import edu.uci.ics.seal.savasana.benchmark.systemUnderTestInterfaces.ComponentBasedSystemManager;
import edu.uci.ics.seal.savasana.benchmark.testset.eds.HQUI;
import edu.uci.ics.seal.savasana.benchmark.testset.eds.SimulationAgent;
import edu.uci.ics.seal.savasana.benchmark.testset.eds.StrategyAnalysisKB;
import edu.uci.ics.seal.savasana.benchmark.testset.eds.map.Map;
import edu.uci.ics.seal.savasana.runtime_old.Adaptor;
import edu.uci.ics.seal.savasana.runtime_old.Main_Old;
import edu.uci.ics.seal.savasana.runtime_old.Main_Old.AdaptationApproach;
import edu.uci.ics.seal.savasana.runtime_old.Main_Old.SerenityCycle;

public class EDSManager implements ComponentBasedSystemManager {

	public static ApplicationContext context;
	public static SerenityCycle mode;
	public static AdaptationApproach approach;
	public static Properties prop = new Properties();

	@Override
	public void adaptComponent() {
		prop.setProperty("map_id", "map_2");
		HQUI.map = (Map) context.getBean(prop.getProperty("map_id"));
		SimulationAgent.map = (Map) context.getBean(prop.getProperty("map_id"));
		StrategyAnalysisKB.map = (Map) context.getBean(prop.getProperty("map_id"));
	}

	@Override
	public Properties getSystemConfig() {
		return prop;
	}



	@Override
	public void initSystem(SerenityCycle cycle, AdaptationApproach method) throws IOException {
		System.out.println("System started");
		prop.load(EDSManager.class.getClassLoader().getResourceAsStream(
				"edu/gmu/serenity/testset/eds/serenityExtension/EDS_Config.properties"));
		context = Main_Old.context;
		approach = method;
		mode = cycle;
	}

	@Override
	public SerenityCycle getMode() {
		return mode;
	}

	@Override
	public void terminateSystem() throws Exception {
		System.out.println("System terminated");
	}

	private void runSystem() throws Exception {
		HQUI hqui = (HQUI) context.getBean("hqui");
		hqui.init();
		hqui.run();
	}
	
	private void runSystemConcurrently(int threadNumbers) {
		Runnable runnable = (Runnable) context.getBean("hqui");
		((HQUI) runnable).init();
		for (int i = 0; i < threadNumbers; i++) {
			Thread thread = new Thread(runnable);
			thread.setName(Adaptor.COMPONENT_THREAD_PREFIX + Integer.toString(i));
			thread.start();
		}
	}

	@Override
	public AdaptationApproach getApproach() {
		return approach;
	}

}
