package edu.uci.ics.seal.savasana.runtime;

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;

import edu.uci.ics.seal.savasana.Const;
import edu.uci.ics.seal.savasana.Util;

@Aspect
public class Executor {

	/**
	 * Add delay to simulate the program execution.
	 */
	@Before("execution(* edu.uci.ics.seal.savasana.benchmark..*.*(..))")
	public void logTransactionInfoBefore(JoinPoint joinPoint) {
		Util.log(Executor.class, "Start " + joinPoint.toShortString() + " of " + Thread.currentThread().getName(), Const.LogLevel.VERBOSE);
		Util.addDelay();
	}

	@After("execution(* edu.uci.ics.seal.savasana.benchmark..*.*(..))")
	public void logTransactionInfoAfter(JoinPoint joinPoint) {
		Util.log(Executor.class, "End " + joinPoint.toShortString() + " of " + Thread.currentThread().getName(), Const.LogLevel.VERBOSE);
	}

}
