package edu.uci.ics.seal.savasana.runtime.model;

public class RegistryKey {

	String componentId;
	String threadName;

	public RegistryKey(String componentId, Thread thread) {
		this.componentId = componentId;
		this.threadName = thread.getName();
	}

	@Override
	public String toString() {
		String comp = componentId.contains(".") ? componentId.substring(componentId.lastIndexOf('.') + 1) : componentId;
		return comp + "(" + threadName + ")";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((componentId == null) ? 0 : componentId.hashCode());
		result = prime * result + ((threadName == null) ? 0 : threadName.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RegistryKey other = (RegistryKey) obj;
		if (componentId == null) {
			if (other.componentId != null)
				return false;
		} else if (!componentId.equals(other.componentId))
			return false;
		if (threadName == null) {
			if (other.threadName != null)
				return false;
		} else if (!threadName.equals(other.threadName))
			return false;
		return true;
	}

	public String getComponentId() {
		return componentId;
	}

	public String getThreadName() {
		return threadName;
	}

}