package edu.uci.ics.seal.savasana.runtime_old;

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.After;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;

@Aspect
public class Logger {

	@Before("execution(* edu.uci.ics.seal.savasana.testset..*.*(..))")
	public void logTransactionInfoBefore(JoinPoint joinPoint) {
		if (joinPoint.getThis().getClass().getPackage().getName().contains("serenityExtension"))
			return;
		System.out.print("Logger: ********************");
		System.out.println("Start " + joinPoint.toShortString() + " of " + Thread.currentThread().getName());
	}

	@After("execution(* edu.uci.ics.seal.savasana.testset..*.*(..))")
	public void logTransactionInfoAfter(JoinPoint joinPoint) {
		if (joinPoint.getThis().getClass().getPackage().getName().contains("serenityExtension"))
			return;
		System.out.print("Logger: ********************");
		System.out.println("End " + joinPoint.toShortString() + " of " + Thread.currentThread().getName());
	}

	@Before("execution(* edu.uci.ics.seal.savasana.testset..*.*(..))")
	public void addDelay(JoinPoint joinPoint) {
		if (joinPoint.getThis().getClass().getPackage().getName().contains("serenityExtension"))
			return;
		try {
			long waitTime = Main_Old.DELAY_UNIT;
			if (Main_Old.RandomServiceDemand)
				waitTime = (long) (Math.random() * Main_Old.DELAY_UNIT * 2);
			Thread.sleep(waitTime);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
