package edu.uci.ics.seal.savasana.staticAnalyisis;

import java.io.File;

import soot.ArrayType;
import soot.RefType;
import soot.Scene;
import soot.SootClass;
import soot.VoidType;
import soot.util.SingletonList;

public class Code2SequenceDiagram {

	public static void doStaticAnalysis(String filter, String inFolder, String outFolder, String outXmlFileName)
			throws Exception {
		String mainClass = findMainClass(inFolder, filter);
		Code2Calltrace callTracer = new Code2Calltrace();
		SequenceTransformer sequenceTransformer = new SequenceTransformer(filter, callTracer);
		SootClass sClass = Scene.v().loadClassAndSupport(mainClass);
		sClass.setApplicationClass();
		sequenceTransformer.processMethod(mainClass, sClass.getMethodByName("main"), true, "---");
		callTracer.buildResultFile(outFolder + "/" + outXmlFileName);
	}

	private static String findMainClass(String inFolder, String filter) throws Exception {
		File rootFolder = new File(inFolder + "/" + filter.replaceAll("\\.", "/"));
		File[] listFiles = rootFolder.listFiles();
		if (listFiles != null) {
			for (File file : listFiles) {
				String fileName = file.getName();
				if (file.isFile() && fileName.endsWith(".java")) {
					SootClass c = Scene.v()
							.loadClassAndSupport(filter + "." + fileName.substring(0, fileName.length() - 5));
					if (c.declaresMethod("main", new SingletonList(ArrayType.v(RefType.v("java.lang.String"), 1)),
							VoidType.v())) {
						return c.getName();
					}
				}
			}
		}
		throw new Exception("No Main Class");
	}

}
