package edu.uci.ics.seal.savasana.staticAnalyisis.model;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import soot.Value;

public class BeanDefinition {

	private String clazz;
	private List<Value> defBoxes;

	public BeanDefinition(String beanId, Value primaryDef, String springAppContext) {
		try {
			clazz = extractBeanClass(springAppContext, beanId);
		} catch (Exception e) {
			e.printStackTrace();
		}
		defBoxes = new ArrayList<Value>();
		defBoxes.add(primaryDef);
	}

	public static String getConcreteClass(List<BeanDefinition> beanDefList, Value use) {
		for (BeanDefinition beanDefinition : beanDefList) {
			if (beanDefinition.defBoxes.contains(use))
				return beanDefinition.clazz;
		}
		return null;
	}

	public String extractBeanClass(String fileName, String beanId) throws ParserConfigurationException, IOException,
			SAXException {
		DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
		DocumentBuilder db = dbf.newDocumentBuilder();
		Document dom = db.parse(fileName);
		Element beans = dom.getDocumentElement();
		NodeList beanList = beans.getElementsByTagName("bean");
		for (int i = 0; i < beanList.getLength(); i++) {
			Element bean = (Element) beanList.item(i);
			if (bean.getAttribute("id").equals(beanId))
				return bean.getAttribute("class");
		}
		return null;
	}

	public static void updateDefBoxes(List<BeanDefinition> beanDefList, Value use, Value def) {
		for (BeanDefinition beanDefinition : beanDefList) {
			if (beanDefinition.defBoxContainsUse(use) && !beanDefinition.defBoxes.contains(def))
				beanDefinition.defBoxes.add(def);
		}
	}
	
	private boolean defBoxContainsUse(Value use){
		for (Value defBox : defBoxes) {
			if(defBox.toString().equals(use.toString()))
				return true;
		}
		return false;
	}
}
