package edu.uci.ics.seal.savasana.staticAnalyisis.model;

import java.util.List;

import soot.Unit;
import soot.Value;
import soot.ValueBox;
import soot.jimple.internal.JInstanceFieldRef;

public class DefUseItem {

	private Value myValue;
	private boolean isDef;

	public DefUseItem(Value value, boolean isDef) {
		this.myValue = value;
		this.isDef = isDef;
	}

	public String getVariable() {
		return ((JInstanceFieldRef) myValue).getField().getName();
	}

	public String getType() {
		return (isDef ? "def" : "use");
	}

	public boolean isDef() {
		return isDef;
	}

	public boolean isCorrespondingTo(DefUseItem that) {
		if (this.getType().equalsIgnoreCase("def") && that.getType().equalsIgnoreCase("use")
				&& this.getVariable().equals(that.getVariable()))
			return true;
		if (this.getType().equalsIgnoreCase("use") && that.getType().equalsIgnoreCase("def")
				&& this.getVariable().equals(that.getVariable()))
			return true;
		return false;
	}

	@Override
	public String toString() {
		return getType() + "(" + getVariable() + ")";
	}

	public static DefUseItem unit2DefUseItem(Unit unit) {
		List<ValueBox> useBoxes = unit.getUseBoxes();
		List<ValueBox> defBoxes = unit.getDefBoxes();
		Value value = null;
		boolean isDef = false;
		for (ValueBox useBox : useBoxes) {
			if (useBox.getValue() instanceof JInstanceFieldRef)
				value = useBox.getValue();
		}
		for (ValueBox defBox : defBoxes) {
			if (defBox.getValue() instanceof JInstanceFieldRef) {
				value = defBox.getValue();
				isDef = true;
			}
		}
		if (value != null)
			return new DefUseItem(value, isDef);
		return null;
	}
}
