package edu.uci.ics.seal.savasana.staticAnalyisis.model;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Registry {

	private static Registry instance;
	// private Map<String, List<String[]>> updatePointsMap;
	private List<String> updatePoints;
	private String regFileName;

	private Registry() {

	}

	public static Registry getInstance(String fileName) {
		if (instance == null) {
			instance = new Registry();
			instance.regFileName = fileName;
			// instance.updatePointsMap = new HashMap<String, List<String[]>>();
			instance.updatePoints = new ArrayList<String>();
		}
		return instance;
	}

	public void saveToFile() {
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(regFileName, true));
			for (String point : updatePoints) {
				writer.write(point + "\n");
			}
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	public void addToRegistry(String point) {
		updatePoints.add(point);
	}

	public boolean isPointInRegistry(String point) {
		if (updatePoints.contains(point))
			return true;
		return false;
	}

	public void loadFromFile() {
		// HashMap<String, List<String[]>> result = new HashMap<String,
		// List<String[]>>();
		BufferedReader reader = null;
		try {
			String sCurrentLine;
			reader = new BufferedReader(new FileReader(regFileName));
			while ((sCurrentLine = reader.readLine()) != null) {
				/*
				 * List<String[]> updatePoints = new ArrayList<String[]>();
				 * String[] lineStrs = sCurrentLine.split(","); String
				 * transactionId = lineStrs[0]; for (int i = 1; i <
				 * lineStrs.length; i++) {
				 * updatePoints.add(lineStrs[i].split(":")); }
				 * result.put(transactionId, updatePoints);
				 */
				updatePoints.add(sCurrentLine);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (reader != null)
					reader.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}
}
